using System;
using System.Collections.Generic;
using System.Text;

namespace ConsoleGeneric
{
    /// <summary>
    /// ,      GenLinkable{T}
    /// </summary>
    public class OneLinkStack<T> : GenStack<T>
    {
        /// <summary>
        ///    ( )
        /// </summary>
        GenLinkable<T> last; 
        /// <summary>
        ///   
        /// </summary>
        public OneLinkStack()
        {
            last = null;
        }
        
        /**
         * <remarks>   </remarks>
         * */
        /// <summary>
        /// require: not empty();
        /// </summary>
        /// <returns> ( )</returns>
        public override T item()
        {
            return (last.Item);
        }//item		
        /// <summary>
        /// require: true;
        /// </summary>
        /// <returns>true   ,  false </returns>
        public override bool empty()
        {
            return (last == null);
        }//empty		
        /// <summary>
        /// require: true; ensure: elem    
        /// </summary>
        /// <param name="elem"></param>
        public override void put(T elem)
        {
            GenLinkable<T> newitem = new GenLinkable<T>();
            newitem.Item = elem; newitem.Next = last;
            last = newitem;
        }//put 		
        /// <summary>
        /// require: not empty();
        /// ensure:   ( )
        /// </summary>
        public override void remove()
        {
            last = last.Next;
        }//remove
    }//class OneLinkStack

}
